      subroutine rmsd(drms)
      include 'DIMENSIONS'
#ifdef MPI
      include 'mpif.h'
#endif
      include 'COMMON.CHAIN'
      include 'COMMON.IOUNITS'  
      include 'COMMON.INTERACT'
      include 'COMMON.ZSCORE'
      logical non_conv
      double precision przes(3),obrot(3,3)
      double precision ccopy(3,maxres2+2),crefcopy(3,maxres2+2)

      iatom=0
c      print *,"nz_start",nz_start," nz_end",nz_end
      do i=nz_start,nz_end
        iatom=iatom+1
        iti=itype(i)
        do k=1,3
         ccopy(k,iatom)=c(k,i+nstart_seq-nstart_sup)
         crefcopy(k,iatom)=cref(k,i)
        enddo
        if (iz_sc.eq.1.and.iti.ne.10) then
          iatom=iatom+1
          do k=1,3
           ccopy(k,iatom)=c(k,nres+i+nstart_seq-nstart_sup)
           crefcopy(k,iatom)=cref(k,nres+i)
          enddo
        endif
      enddo

      call fitsq(roznica,ccopy(1,1),crefcopy(1,1),iatom,
     &                                      przes,obrot,non_conv) 
      if (non_conv) then
          print *,'Problems in FITSQ!!! rmsd'
          write (iout,*) 'Problems in FITSQ!!! rmsd'
          print *,'Ccopy and CREFcopy'
          write (iout,*) 'Ccopy and CREFcopy'
          print '(i5,3f10.5,5x,3f10.5)',(k,(ccopy(j,k),j=1,3),
     &           (crefcopy(j,k),j=1,3),k=1,iatom)
          write (iout,'(i5,3f10.5,5x,3f10.5)') (k,(ccopy(j,k),j=1,3),
     &           (crefcopy(j,k),j=1,3),k=1,iatom)
#ifdef MPI
c          call mpi_abort(mpi_comm_world,ierror,ierrcode)
           roznica=100.0
#else          
          stop
#endif
       endif
       drms=dsqrt(dabs(roznica))
       return
       end

c--------------------------------------------
      subroutine rmsd_csa(drms)
      include 'DIMENSIONS'
#ifdef MPI
      include 'mpif.h'
#endif
      include 'COMMON.CHAIN'
      include 'COMMON.IOUNITS'  
      include 'COMMON.INTERACT'
      include 'COMMON.ZSCORE'
      logical non_conv
      double precision przes(3),obrot(3,3)
      double precision ccopy(3,maxres2+2),crefcopy(3,maxres2+2)

      iatom=0
      do i=nz_start,nz_end
        iatom=iatom+1
        iti=itype(i)
        do k=1,3
         ccopy(k,iatom)=c(k,i)
         crefcopy(k,iatom)=crefjlee(k,i)
        enddo
        if (iz_sc.eq.1.and.iti.ne.10) then
          iatom=iatom+1
          do k=1,3
           ccopy(k,iatom)=c(k,nres+i)
           crefcopy(k,iatom)=crefjlee(k,nres+i)
          enddo
        endif
      enddo

      call fitsq(roznica,ccopy(1,1),crefcopy(1,1),iatom,
     &                                      przes,obrot,non_conv) 
      if (non_conv) then
          print *,'Problems in FITSQ!!! rmsd_csa'
          write (iout,*) 'Problems in FITSQ!!! rmsd_csa'
          print *,'Ccopy and CREFcopy'
          write (iout,*) 'Ccopy and CREFcopy'
          print '(i5,3f10.5,5x,3f10.5)',(k,(ccopy(j,k),j=1,3),
     &           (crefcopy(j,k),j=1,3),k=1,iatom)
          write (iout,'(i5,3f10.5,5x,3f10.5)') (k,(ccopy(j,k),j=1,3),
     &           (crefcopy(j,k),j=1,3),k=1,iatom)
#ifdef MPI
          call mpi_abort(mpi_comm_world,ierror,ierrcode)
#else          
          stop
#endif
       endif
       drms=dsqrt(dabs(roznica))
       return
       end

      subroutine write_rmsbank
      include 'DIMENSIONS'
      include 'COMMON.CONTROL'
      include 'COMMON.IOUNITS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.SBRIDGE'
      include 'COMMON.RMSDBANK'
      integer lenpre,lenpot,ilen
      external ilen
      character*3 liczba

      lenpre=ilen(prefix)
      if(modecalc.eq.9) then
       call numstr(iter_zs,liczba)
       open(igeom,file=prefix(:lenpre)//liczba//'_zs.int')
      else
       open(igeom,file=prefix(:lenpre)//'_zs.int')
      endif

      do it=1,nrmsdb
      ener=rmsdbank_e(it)
      call var_to_geom(nvar,rmsdbank_c(1,it))
      IF (NSS.LE.9) THEN
        WRITE (igeom,180) IT,ENER,NSS,(IHPB(I),JHPB(I),I=1,NSS)
      ELSE
        WRITE (igeom,180) IT,ENER,NSS,(IHPB(I),JHPB(I),I=1,9)
        WRITE (igeom,190) (IHPB(I),JHPB(I),I=10,NSS)
      ENDIF
      WRITE (igeom,200) (RAD2DEG*THETA(I),I=3,NRES)
      WRITE (igeom,200) (RAD2DEG*PHI(I),I=4,NRES)
      write (igeom,200) (rad2deg*alph(i),i=2,nres-1)
      write (igeom,200) (rad2deg*omeg(i),i=2,nres-1)
      enddo
      close(igeom)
  180 format (I5,F12.5,I2,9(1X,2I3))
  190 format (3X,11(1X,2I3))
  200 format (8F10.4)

      return
      end

      subroutine write_rmsbank1
      include 'DIMENSIONS'
      include 'COMMON.CONTROL'
      include 'COMMON.IOUNITS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.SBRIDGE'
      include 'COMMON.RMSDBANK'
      integer lenpre,lenpot,ilen
      external ilen
      character*3 liczba

      if (nrmsdb1.le.0) return

      lenpre=ilen(prefix)
      if(modecalc.eq.9) then
       call numstr(iter_zs,liczba)
       open(izs1,file=prefix(:lenpre)//liczba//'_zs1.int')
      else
       open(izs1,file=prefix(:lenpre)//'_zs1.int',err=102)
      endif

      do it=1,nrmsdb1
      ener=rmsdbank_e1(it)
      call var_to_geom(nvar,rmsdbank_c1(1,it))
      IF (NSS.LE.9) THEN
        WRITE (izs1,180) IT,ENER,NSS,(IHPB(I),JHPB(I),I=1,NSS)
      ELSE
        WRITE (izs1,180) IT,ENER,NSS,(IHPB(I),JHPB(I),I=1,9)
        WRITE (izs1,190) (IHPB(I),JHPB(I),I=10,NSS)
      ENDIF
      WRITE (izs1,200) (RAD2DEG*THETA(I),I=3,NRES)
      WRITE (izs1,200) (RAD2DEG*PHI(I),I=4,NRES)
      write (izs1,200) (rad2deg*alph(i),i=2,nres-1)
      write (izs1,200) (rad2deg*omeg(i),i=2,nres-1)
      enddo
  102 continue
      close(izs1)
  180 format (I5,F12.5,I2,9(1X,2I3))
  190 format (3X,11(1X,2I3))
  200 format (8F10.4)

      return
      end

      subroutine rmsbank(var,ene)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'COMMON.SETUP'
      include 'COMMON.GEO'
      include 'COMMON.CHAIN'
      include 'COMMON.ZSCORE'
      include 'COMMON.RMSDBANK'
      dimension var(maxvar),iflag(maxrmsdb)
      logical non_conv
      double precision przes(3),obrot(3,3)

c      print *,'entering rmsbank ',ene
      call var_to_geom(nvar,var)
      call chainbuild
      do k=1,nres*2
       do kk=1,3
        cref(kk,k)=c(kk,k)
       enddo
      enddo
      nflag=0
      il=0
      ij=0
      ihigh=1
      enem=ene
      rmin=1.0d+99
      do i=1,nrmsdb
       call var_to_geom(nvar,rmsdbank_c(1,i))
       call chainbuild
       call rmsd(roznica)
       if(rmin.gt.roznica)rmin=roznica
       if(rmsdbank_e(i).gt.rmsdbank_e(ihigh))ihigh=i
       if(roznica.lt.rmsdbc) then
        nflag=nflag+1
        iflag(nflag)=i
        if(ene.lt.rmsdbank_e(i))ij=1
        if(enem.gt.rmsdbank_e(i)) then
         il=i
         enem=rmsdbank_e(i)
        endif
       endif
      enddo
     
c      print *,'CHUJ - ',rmin,rmsdbc,'(',nrmsdb,') nflag=',nflag,il,ij 
      if(nrmsdb.lt.maxrmsdb) then
       if(nflag.eq.0) then
        nrmsdb = nrmsdb + 1
c        print *,'CHUJ - adding ',nrmsdb
        rmsdbank_e(nrmsdb) = ene
        do i=1, nvar
         rmsdbank_c(i,nrmsdb) = var(i)
        enddo
       elseif(ij.ne.0) then
c        print *,'CHUJ - REPLACING ',(rmsdbank_e(iflag(i)),i=1,nflag),
c     &    ' with ',nrmsdb,il
        do i=nflag,1,-1
         iz=iflag(i)
         if(iz.ne.il) then
          call remove_rmsdb(iflag(i)) 
          nrmsdb=nrmsdb-1
         endif
        enddo
        if(il.eq.0) then
         nrmsdb = nrmsdb + 1
         rmsdbank_e(nrmsdb) = ene
         do i=1, nvar
          rmsdbank_c(i,nrmsdb) = var(i)
         enddo
        endif
       endif
      else 
       if(nflag.eq.0) then
        if(ene.lt.rmsdbank_e(ihigh)) then
c         print *,'CHUJ -hreplacing ',ihigh,rmsdbank_e(ihigh),
c     &    ' with ',ihigh
         rmsdbank_e(ihigh) = ene
         do i=1, nvar
          rmsdbank_c(i,ihigh) = var(i)
         enddo 
        endif
       elseif(ij.ne.0) then
c        print *,'CHUJ - replacing ',(rmsdbank_e(iflag(i)),i=1,nflag),
c     &    ' with ',nrmsdb-nflag+1,il
        do i=nflag,1,-1
         iz=iflag(i)
         if(il.ne.iz) then
          call remove_rmsdb(iflag(i))
          nrmsdb = nrmsdb - 1
         endif
        enddo
        if(il.eq.0) then
         nrmsdb = nrmsdb + 1
         rmsdbank_e(nrmsdb) = ene
         do i=1, nvar
          rmsdbank_c(i,nrmsdb) = var(i)
         enddo
        endif
       endif
      endif 
c      print *,'exiting rmsbank'

      return
      end

      subroutine rmsbank1(var,ene)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'COMMON.SETUP'
      include 'COMMON.GEO'
      include 'COMMON.CHAIN'
      include 'COMMON.ZSCORE'
      include 'COMMON.RMSDBANK'
      dimension var(maxvar),iflag(maxrmsdb)
      logical non_conv
      double precision przes(3),obrot(3,3)
      double precision difrms(maxrmsdb)

c      print *,'entering rmsbank1'
      call var_to_geom(nvar,var)
      call chainbuild
      do k=1,nres*2
       do kk=1,3
        cref(kk,k)=c(kk,k)
       enddo
      enddo
      call var_to_geom(nvar,coord_exp_zs(1,1))
      call chainbuild
      call rmsd(roznica)
      if(roznica.gt.rmsdbcm) then
c       print *,'exiting rmsbank1 short'
       return
      endif
      rmm=roznica

      nflag=0
      il=0
      ij=0
      irlo=0
      irlo1=1
      irlo11=1
      irma1=1
      wrlo=rmm
      ihigh=1
      enem=ene
      rmin=1.0d+99
      do i=1,nrmsdb1
c       print *,i
       call var_to_geom(nvar,rmsdbank_c1(1,i))
       call chainbuild
       call rmsd(roznica)
       difrms(i)=roznica
       if(rmin.gt.roznica)rmin=roznica
       if(rmsdbank_e1(i).gt.rmsdbank_e1(ihigh))ihigh=i
       if(rmsdbank_r1(i).lt.rmsdbank_r1(irlo1))irlo1=i
       if(rmsdbank_r1(i).gt.rmsdbank_r1(irma1))irma1=i
       if(roznica.lt.rmsdbc1c) then
         nflag=nflag+1
         iflag(nflag)=i
         if(ene.lt.rmsdbank_e1(i))ij=1
         if(enem.gt.rmsdbank_e1(i)) then
          il=i
          enem=rmsdbank_e1(i)
         endif
         if(wrlo.gt.rmsdbank_r1(i)) then
          irlo=i
          wrlo=rmsdbank_r1(i)
         endif
       endif
      enddo
     
c      print *,'CHUJ - ',rmm,rmsdbc1,'(',nrmsdb1,') nflag=',nflag 
      if(nrmsdb1.lt.maxrmsdb) then
       if(nflag.eq.0) then
        nrmsdb1 = nrmsdb1 + 1
c        print *,'CHUJ - adding ',nrmsdb1,rmm
        rmsdbank_e1(nrmsdb1) = ene
        rmsdbank_r1(nrmsdb1) = rmm
        do i=1, nvar
         rmsdbank_c1(i,nrmsdb1) = var(i)
        enddo
        do i=1,nrmsdb1-1
         rmstb(i,nrmsdb1)=difrms(i)
         rmstb(nrmsdb1,i)=difrms(i)
        enddo
        rmstb(nrmsdb1,nrmsdb1)=0.0d0
       elseif(ij.ne.0) then
c        print *,'CHUJ - RREPLACING ',(iflag(i),i=1,nflag)
        do i=nflag,1,-1
         iz=iflag(i)
         if(iz.ne.il.and.iz.ne.irlo) then
          call remove_rmsdb1(iflag(i)) 
          nrmsdb1=nrmsdb1-1
         endif
        enddo
        if(il.eq.0.or.irlo.eq.0) then
         nrmsdb1 = nrmsdb1 + 1
         rmsdbank_e1(nrmsdb1) = ene
         rmsdbank_r1(nrmsdb1) = rmm
         do i=1, nvar
          rmsdbank_c1(i,nrmsdb1) = var(i)
         enddo
         do i=1,nrmsdb1-1
          rmstb(i,nrmsdb1)=difrms(i)
          rmstb(nrmsdb1,i)=difrms(i)
         enddo
         rmstb(nrmsdb1,nrmsdb1)=0.0d0
        endif
       endif
      else 
       ieq=0
       rchuj=0.0d0
100    rmsdbc1c=rmsdbc1c+drms*rchuj
c       print *,'***',rmsdbc1c
       rchuj=1.0d0
       if(rmsdbc1c.gt.rmsdbc1max)rmsdbc1c=rmsdbc1max
       do i=2, nrmsdb1
        do j=i-1,nrmsdb1
         if(rmstb(i,j).le.rmsdbc1c)ieq=ieq+1
        enddo
       enddo
       do i=1, nrmsdb1
        if(difrms(i).le.rmsdbc1c)ieq=ieq+1
       enddo
       if(rmsdbc1c.lt.rmsdbc1max.and.ieq.eq.0) go to 100
       if(rmsdbc1c.eq.rmsdbc1max.and.ieq.eq.0) then
       if(nflag.eq.0) then
        iii=0
        if(ene.lt.rmsdbank_e1(ihigh).and.ihigh.ne.irlo1)iii=ihigh
        if(rmm.lt.rmsdbank_r1(irlo1).and.iii.eq.0)iii=ihigh
        if(iii.gt.0) then
c         print *,'CHUJ -hreplacing ',iii
         rmsdbank_e1(iii) = ene
         rmsdbank_r1(iii) = rmm
         do i=1, nvar
          rmsdbank_c1(i,iii) = var(i)
         enddo 
         do i=1,nrmsdb1-1
          rmstb(i,iii)=difrms(i)
          rmstb(iii,i)=difrms(i)
         enddo
         rmstb(iii,iii)=0.0d0
        endif
       elseif(ij.ne.0) then
c        print *,'CHUJ - replacing ',(iflag(i),i=1,nflag)
        do i=nflag,1,-1
         iz=iflag(i)
         if(il.ne.iz.and.iz.ne.irlo) then
          call remove_rmsdb1(iflag(i))
          nrmsdb1 = nrmsdb1 - 1
         endif
        enddo
        if(il.eq.0.or.irlo.eq.0) then
         nrmsdb1 = nrmsdb1 + 1
         rmsdbank_e1(nrmsdb1) = ene
         rmsdbank_r1(nrmsdb1) = rmm
         do i=1, nvar
          rmsdbank_c1(i,nrmsdb1) = var(i)
         enddo
         do i=1,nrmsdb1-1
          rmstb(i,nrmsdb1)=difrms(i)
          rmstb(nrmsdb1,i)=difrms(i)
         enddo
         rmstb(nrmsdb1,nrmsdb1)=0.0d0
        endif
       endif
       else
c do clustering
c       print *,'do clustering'
        nrmsdb1 = nrmsdb1 + 1
        rmsdbank_e1(nrmsdb1) = ene
        rmsdbank_r1(nrmsdb1) = rmm
        do i=1, nvar
         rmsdbank_c1(i,nrmsdb1) = var(i)
        enddo
        do i=1,nrmsdb1-1
         rmstb(i,nrmsdb1)=difrms(i)
         rmstb(nrmsdb1,i)=difrms(i)
        enddo
        rmstb(nrmsdb1,nrmsdb1)=0.0d0
        if(rmm.lt.rmsdbank_r1(irlo1))irlo1=nrmsdb1
        in=0
        ijchu=0
110     in=in+1
c        print *,'>>>',in
        do i=1, nrmsdb1
         iflag(i)=0
        enddo
        il=1
        il1=1
        iflag(1)=in
        eee=rmsdbank_e1(in)
        do i=in+1, nrmsdb1
         if(rmstb(in,i).le.rmsdbc1c) then
          il=il+1
          iflag(il)=i
          if(eee.gt.rmsdbank_e1(i)) then
           il1=i
           eee=rmsdbank_e1(i)
          endif
c          if(i.eq.irlo1) then
c           eee=-1.0d99
c           il1=i
c          endif
         endif
        enddo
        if(il.gt.1) then
         do i=1,il
          jj=iflag(i)
          k=0
          do j=i,il
           if(jj.lt.iflag(j)) then
            k=j
            jj=iflag(j)
           endif
          enddo
          if(k.gt.0) then
           jj=iflag(i)
           iflag(i)=iflag(k)
           iflag(k)=jj
          endif
         enddo
         do i=1,il
          if(il1.ne.iflag(i).and.irlo1.ne.iflag(i)) then
           ijchu=ijchu+1
           call remove_rmsdb1(iflag(i))
           nrmsdb1 = nrmsdb1 - 1
          endif
         enddo
        endif
        if(in.lt.nrmsdb1-1)go to 110
       endif
      endif 
      if(ijchu.eq.0) then
       ij=1
       do i=1,nrmsdb1
        if(rmsdbank_e1(i).gt.rmsdbank_e1(ij))ij=i
       enddo
       call remove_rmsdb1(ij)
       nrmsdb1 = nrmsdb1 - 1
      endif
      www=rmsdbank_r1(1)
      ilrms=1
      do i=1, nrmsdb1 
       if(www.gt.rmsdbank_r1(i)) then
        ilrms=i
        www=rmsdbank_r1(i)
       endif
      enddo
c      print *, 'exiting rmsbank1'

      return
      end

      subroutine remove_rmsdb(ii)
      include 'DIMENSIONS'
      include 'COMMON.RMSDBANK'
      include 'COMMON.VAR'
 
      if(ii.eq.nrmsdb)return
      do i=ii, nrmsdb-1
       do j=1,nvar
        rmsdbank_c(j,i)=rmsdbank_c(j,i+1) 
       enddo
       rmsdbank_e(i)=rmsdbank_e(i+1)
      enddo
      return
      end


      subroutine remove_rmsdb1(ii)
      include 'DIMENSIONS'
      include 'COMMON.RMSDBANK'
      include 'COMMON.ZSCORE'
      include 'COMMON.VAR'
 
      if(ii.eq.nrmsdb1)return
      do i=ii,nrmsdb1-1
       do j=1,ii
        rmstb(i,j)=rmstb(i+1,j)
        rmstb(j,i)=rmstb(j,i+1)
       enddo
       do j=ii,nrmsdb-1
        rmstb(j,i)=rmstb(j+1,i+1)
       enddo
      enddo
      do i=ii, nrmsdb1
       do j=1,nvar
        rmsdbank_c1(j,i)=rmsdbank_c1(j,i+1) 
       enddo
       rmsdbank_e1(i)=rmsdbank_e1(i+1)
       rmsdbank_r1(i)=rmsdbank_r1(i+1)
      enddo
      return
      end

